FPSMeterClass = function()
{
   this.listenersList = [];
   this.init();
};
Object.registerClass("FPSMeter",FPSMeterClass);
FPSMeterClass.prototype.init = function()
{
   if(this._targetInstanceName.length > 0)
   {
      this.FPSMeterTarget = this.targetInstance = this._parent[this._targetInstanceName];
      if(this.FPSMeterTarget instanceof TextField)
      {
         this._visible = false;
         this.past = 0;
         this.now = 0;
         this.fps = 0;
         this.pass = 0;
         this.delta = 0;
         this.population = new Array(this.populationSize);
      }
      else
      {
         trace("FPSMeter Component: no target TextField found!");
      }
   }
};
FPSMeterClass.prototype.onEnterFrame = function()
{
   this.now = getTimer();
   this.delta = this.now - this.past;
   if(this.modus)
   {
      this.population[this.pass] = this.delta;
      this.pass = this.pass + 1;
      if(this.pass >= this.populationSize)
      {
         var sum = 0;
         for(var measurement in this.population)
         {
            sum += this.population[measurement];
         }
         this.fps = int(1000 * this.populationSize / sum);
         this.sendFPSMeterEvent(this.fps);
         this.pass = 0;
      }
   }
   else
   {
      this.fps = int(1000 / this.delta);
      this.sendFPSMeterEvent(this.fps);
   }
   this.past = this.now;
};
FPSMeterClass.prototype.getFPS = function()
{
   return this.fps;
};
FPSMeterClass.prototype.addListener = function(ref)
{
   this.listenersList[ref] = ref;
};
FPSMeterClass.prototype.removeListener = function(ref)
{
   delete this.listenersList[ref];
};
FPSMeterClass.prototype.sendFPSMeterEvent = function(value)
{
   this.FPSMeterTarget.text = this.prefix + value + this.suffix;
   for(var i in this.listenersList)
   {
      this.listenersList[i].getFPS(value);
   }
};
